<template>
    <div class="user-type-menu">
        <template v-for="route in usersRouter">
            <router-link v-if="route.meta && route.meta.menuLabel" :key="route.name" :class="isActive(route.path)" :to="routePath(route)">
                <span>{{route.meta.menuLabel}}</span>
            </router-link>
        </template>
    </div>
</template>

<script>
import { checkIdentical, filterQuery, sortQuery } from '@bloomio/spa-admin-common/utils';
import { defaultSorting } from '@/constants/ui/listings';
import { mapState } from 'vuex';

/**
 * Menu for user listings with dynamic route paths for applying filters and sorting
 */
export default {
    computed: {
        usersRouter() {
            const res = this.$router.options.routes.reduce((accumulator, current) => {
                if (current.path === '/') {
                    return current.children;
                }
                return accumulator;
            }, []);
            return res;
        },
        isActive: vm => path => ((vm.$route.path === path) ? 'selected' : 'unselected'),
        ...mapState({
            allFilter: state => state.users.users_filter,
            allSorting: state => state.users.all_users_sorting,
            investorsFilter: state => state.users.investors_filter,
            investorsSorting: state => state.users.investors_sorting,
            startupsFilter: state => state.users.startups_filter,
            startupsSorting: state => state.users.startups_sorting,
        }),
        routePath: vm => route => (route.path + vm.queryFromStore(route.name)),
        queryFromStore: vm => (name) => {
            let result = '?';
            result += filterQuery(vm[`${name}Filter`]);
            result += (checkIdentical(defaultSorting, vm[`${name}Sorting`]) && !vm.$route.query.order) ? '' : sortQuery(vm[`${name}Sorting`]);
            return result;
        },
    },
};
</script>

<style lang="stylus" scoped>
.user-type-menu
  display: flex
  padding-bottom: 1rem

.selected
    color: $dark_gray

.unselected
    color: $base_blue

span
    margin-right: 2rem
    font-weight: 600
    cursor: pointer

</style>

